#ifdef USE_TI89
    #include "Lava.h"
    #undef KEY_UP
    #undef KEY_DOWN
    #undef KEY_RIGHT
    #undef KEY_LEFT
    #undef KEY_ESC
    #define LCD_W		160
    #define LCD_H		100//debug
#else
    #define LCD_W		160
    #define LCD_H		80
#endif

#define	WB_COPY	1
#define	WB_NOT	2
#define	WB_OR	3
#define	WB_AND	4
#define	WB_XOR	5

#define KEY_UP      20
#define KEY_DOWN    21
#define KEY_RIGHT   22
#define KEY_LEFT    23
#define	KEY_F1		28
#define	KEY_F2		29
#define KEY_ENTER   13
#define KEY_SPACE   20
#define KEY_HELP    25
#define	KEY_ESC		27

//----------------------------------------------------------------
#define OBJECT_WIDTH_DOT	16
#define OBJECT_HEIGHT_DOT	20
#define Y_OFFSET			400			//20*20	LCD_WIDTH_BYTE*OBJECT_HEIGHT_DOT
#define OBJECT_DATA_SIZE	40			//2*20 OBJECT_WIDTH_BYTE*OBJECT_HEIGHT_DOT
//----------------------------------------------------------------
#define LCD_MAX_WIDTH_OBJ		(LCD_W/OBJECT_WIDTH_DOT)
#define LCD_MAX_HEIGHT_OBJ		((LCD_H+10)/OBJECT_HEIGHT_DOT)//debug
#define LCD_HEIGHT_START		0
#define LCD_HEIGHT_END			(LCD_MAX_HEIGHT_OBJ-1)//debug
#define LCD_WIDTH_START			0
#define LCD_WIDTH_END			(LCD_MAX_WIDTH_OBJ-1)
#define FIX_H           ((LCD_H-80+10)/OBJECT_HEIGHT_DOT)


#define OBJ_BLANK		0
#define OBJ_TREE		1
#define OBJ_BRICK		2
#define OBJ_GRAY		3
#define OBJ_MAN			4
#define OBJ_MAN2		5
#define OBJ_GLOBALVIEW1	6
#define OBJ_GLOBALVIEW2	7
#define OBJ_GLOBALVIEW3	8
#define OBJ_GLOBALVIEW4	9
#define OBJ_GLOBALVIEW5	10
#define OBJ_GLOBALVIEW6	11
#define OBJ_GLOBALVIEW7	12
#define OBJ_GLOBALVIEW8	13
#define OBJ_DR			14
#define OBJ_DRHOUSE1	15
#define OBJ_DRHOUSE2	16
#define OBJ_DRHOUSE3	17
#define OBJ_DRHOUSE4	18
#define OBJ_DRHOUSE5	19
#define OBJ_DRHOUSE6	20
#define OBJ_SLEEP		21
#define OBJ_OFFICE1   	22
#define OBJ_OFFICE2   	23
#define OBJ_SMILE		24
#define OBJ_OFFICE3   	25
#define OBJ_OFFICE4   	26
#define OBJ_OFFICE5   	27
#define OBJ_OFFICE6   	28
#define OBJ_CHEMICAL	29
#define OBJ_RICHHOUSE1  30
#define OBJ_RICHHOUSE2	31
#define OBJ_RICHHOUSE3	32
#define OBJ_RICHHOUSE4	33
#define OBJ_RICHHOUSE5	34
#define OBJ_RICHHOUSE6	35
#define OBJ_RICHHOUSE7	36
#define OBJ_RICHHOUSE8	37
#define OBJ_RICHHOUSE9	38
#define OBJ_RAPID1		40
#define OBJ_RAPID2		41
#define OBJ_RAPID3		42
#define OBJ_RAPID4		43
#define OBJ_RAPID5		44
#define OBJ_RAPID6		45
#define OBJ_DOORCLOSE	46
#define OBJ_DOOROPEN	47
#define OBJ_STAIR1		48
#define OBJ_STAIR2		49
#define OBJ_FLOWER		50
#define OBJ_HOME1		51
#define OBJ_HOME2		52
#define OBJ_HOME3		53
#define OBJ_HOME4		54
#define OBJ_TABLE		55
#define OBJ_CABINET		56
#define OBJ_GIRL		57
#define OBJ_BED			58
#define OBJ_POLICE		59
#define OBJ_SLINGSHOT	60
#define OBJ_TICKETMACHINE	61
#define OBJ_MONEY		62
#define OBJ_TICKET		63
#define OBJ_CELLPHONE	64
#define OBJ_STREETLAMP	65
#define OBJ_INVOICE		66
#define OBJ_COMPUTER	67
#define OBJ_CC800		68
#define OBJ_WATER		69
#define OBJ_CABINET_OPEN	70
#define OBJ_BADMANL		71
#define OBJ_BADMANR		72
#define OBJ_RAPIDCAR1	73
#define OBJ_RAPIDCAR2	74
#define OBJ_RAPIDCAR3	75
#define OBJ_TRACK		76
#define OBJ_CLOSESTOOL	77
#define OBJ_TOILETPAPER	78
#define OBJ_SAD			79
#define OBJ_ASSISTANT	80

//----------------------------------------------------------------
//#define LEFT_ARROW	  23
//#define RIGHT_ARROW  22
//#define UP_ARROW     20
//#define DOWN_ARROW   21
//#define KEY_ENTER		13
//#define KEY_ESC		27
//#define KEY_HELP		25
//----------------------------------------------------------------
#define DELAY_TIME		200
//----------------------------------------------------------------
#define TALK		0
#define SEARCH		1
#define USE			2
//----------------------------------------------------------------
#define MAP_MAX_WIDTH_OBJ		31
#define MAP_MAX_HEIGHT_OBJ		30
//----------------------------------------------------------------
char MapData[MAP_MAX_HEIGHT_OBJ][MAP_MAX_WIDTH_OBJ];
char MapBackup[MAP_MAX_HEIGHT_OBJ][MAP_MAX_WIDTH_OBJ] =
{
    //	ͼ1
    01,01,01,01,01,30,31,32,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,
    01,15,16,17,01,33,34,35,01,01, 0, 0,51,52,01, 0, 0, 0, 0, 0,01,40,41,42,01, 0,01, 0, 0, 0,01,
    01,14,19,20,65,36,37,38, 0,01, 0, 0,53,54,01, 0, 0, 0, 0, 0,01,43,44,45,65, 0,01,01,01, 0,01,
    01, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,01, 0, 0, 0, 0, 0,01, 0,01, 0,01,
    01,01,65, 0,01,01,01,01,65,01,01,01,01,01, 0,01,01,65,01,01,01, 0, 0,01, 0, 0,01, 0,01, 0,01,
    01,01, 0, 0, 0,01,01,01,40,41,42,01, 0, 0, 0,01,01,22,23,01,01, 0, 0,01, 0,01, 0, 0, 0, 0,01,
    01, 0,01,01, 0, 0,01,01,43,44,45,01, 0, 0, 0,01,25,26,27,28,01,01, 0, 0, 0, 0, 0, 0, 0,01,01,
    01, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,01,01, 0, 0, 6, 7, 8, 9, 0, 0,01,
    01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01, 0,10,11,12,13,65, 0,01,
      
    //10            x05            x10            x15            x20
    01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01, 0, 0, 0, 0, 0, 0, 0,01,
    01, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,01,01,01,01,01,01,01,01,01,01,01,
    01, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,01,
    01, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,01,
    01, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,01,
    03,03,03,03,03,03,03,03,03,03, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,01,
    76,02,02,02,03,02,02,61,02,02, 0,03,03,03,03,03,03,03,03,03,03, 0, 0, 0, 0, 0, 0, 0, 0, 0,01,
    73, 0, 0, 0,46, 0, 0, 0, 0,48, 0,03,02,02,02,02,02,02,56,02,03, 0, 0, 0, 0, 0, 0, 0, 0, 0,01,
    74, 0, 0, 0,03, 0, 0, 0, 0,03, 0,03,50, 0, 0, 0,55, 0, 0,58,03, 0, 0, 0, 0, 0, 0, 0, 0, 0,01,
    75, 0, 0, 0,46, 0, 0, 0,50,03, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,03, 0, 0, 0, 0, 0, 0, 0, 0, 0,01,
    76,03,03,03,03,03,03,03,03,03, 0,03,03,03,03,03,03,03,03,03,03, 0, 0, 0, 0, 0, 0, 0, 0, 0,01,
    
    //20            x05            x10            x15            x20            x25
    03,56,02,02,02,02,02,02,02,03, 0,03,02,02,02,02,02,03,02,56,03,03,03,03,03,03,03,03,03,03,03,
    03, 0, 0, 0, 0, 0, 0, 0, 0,03, 0,03, 0, 0, 0, 0, 0,47, 0, 0,03,03,02,02,03,02,56,03,02,02,03,
    03, 0, 0,03, 0, 0,03,80, 0,03, 0,03, 0, 0, 0, 0, 0,03, 0, 0,03,03, 0, 0,03,77, 0,03, 0, 0,03,
    03,55,67,03, 0, 0,03, 0,67,03, 0,03, 0,03, 0, 0, 0,03,58, 0,47,03, 0, 0,46, 0, 0,47, 0, 0,03,
    03,03,03,03, 0, 0,03,03,03,03, 0,03, 0,03,03,03,03,03,03,03,03,03, 0, 0,03,03,03,03, 0, 0,03,
    03,02,02,02, 0, 0,02,02,02,03, 0,03,56,02,03,02,02,02,02,02,03,03, 0, 0,02,03,02,02, 0, 0,03,
    03,50, 0, 0, 0, 0, 0, 0, 0,03, 0,49, 0, 0,46, 0, 0, 0, 0, 0,03,03, 0, 0, 0,03, 0, 0, 0, 0,03,
    03,03,03,03,03, 0,03,03,03,03, 0,03, 0, 0,03, 0, 0, 0, 0, 0, 0,03, 0, 0,72,46, 0, 0, 0, 0,46,
    02,02,02,02,02, 0,02,02,02,02, 0,03, 0,57,55, 0, 0, 0, 0, 0,03,03, 0, 0, 0,03, 0, 0, 0,14,03,
    01, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,03,03,03,03,03,03,03,03,03,03,03,03,03,03,03,03,03,03,03,03
};

char GraphicData[][40] =
{
//Blank
    0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00,
    0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00,       
                                                                                                          
//Tree
    0x00,0x00, 0x00,0x00, 0x1F,0xF8, 0x1E,0xFC, 0x75,0x54, 0xBA,0xBF, 0xD5,0x55, 0xEE,0xEF, 0xD5,0x55, 0x6A,0xAB,
    0x55,0x55, 0x6E,0xEF, 0x75,0x56, 0x1A,0xBA, 0x1F,0xD6, 0x01,0xFC, 0x01,0xE0, 0x01,0xA0, 0x01,0xA0, 0x01,0xE0,       
                                                                                                          
//Brick
    0x3B,0xBB, 0x1F,0x1F, 0x0E,0x0E, 0x1C,0x1C, 0x38,0x38, 0x70,0x70, 0xE0,0xE0, 0xF1,0xF1, 0xBB,0xBB, 0x1F,0x1F,
    0x0E,0x0E, 0x1C,0x1C, 0x38,0x38, 0x70,0x70, 0xE0,0xE0, 0xF1,0xF1, 0xBB,0xBB, 0x1F,0x1F, 0x0E,0x0E, 0x1C,0x1C,       
                                                                                                          
//Gray
    0x88,0x88, 0x44,0x44, 0x22,0x22, 0x11,0x11, 0x88,0x88, 0x44,0x44, 0x22,0x22, 0x11,0x11, 0x88,0x88, 0x44,0x44,
    0x22,0x22, 0x11,0x11, 0x88,0x88, 0x44,0x44, 0x22,0x22, 0x11,0x11, 0x88,0x88, 0x44,0x44, 0x22,0x22, 0x11,0x11,       
                                                                                                          
//Man
    0x3F,0xFC, 0x7F,0xFE, 0xFF,0xFE, 0x7F,0xFF, 0x69,0xB6, 0xA0,0x05, 0x60,0x06, 0x20,0x04, 0x19,0x88, 0x04,0x30,
    0x3B,0xCC, 0x50,0x0A, 0x50,0x0A, 0x50,0x0A, 0x6F,0xFA, 0x1F,0xF6, 0x38,0x70, 0x38,0x70, 0x1C,0x70, 0x3C,0x78,
    0x3F,0xFC, 0x7F,0xFE, 0xFF,0xFE, 0x7F,0xFF, 0x69,0xB6, 0xA0,0x05, 0x60,0x06, 0x20,0x04, 0x19,0x88, 0x04,0x30,
    0x3B,0xCC, 0x50,0x0A, 0x50,0x0A, 0x50,0x0A, 0x5F,0xF6, 0x3F,0xF8, 0x0E,0x1C, 0x0E,0x1C, 0x0E,0x38, 0x1E,0x3C,     
                                                                                                          
//Global View
    0x00,0x00, 0x02,0x08, 0x01,0x7F, 0x00,0x88, 0x01,0x7F, 0x04,0x3E, 0x1A,0x22, 0x27,0x3E, 0x41,0x19, 0x41,0x2E,
    0x21,0x49, 0x22,0x88, 0x24,0x7F, 0x10,0x00, 0x10,0x07, 0x10,0x07, 0x08,0x07, 0x08,0x07, 0x0C,0x03, 0x04,0x03,
    0x00,0x00, 0x08,0x10, 0x0F,0xF8, 0x08,0x10, 0x8F,0xF1, 0x78,0x16, 0x0F,0xF0, 0x08,0x10, 0x0F,0xF0, 0x02,0x40,
    0x0A,0x44, 0x0C,0x44, 0xB8,0x7F, 0x00,0x00, 0x3C,0x20, 0xC4,0x10, 0x04,0x10, 0x04,0x10, 0x04,0x1F, 0x87,0xF0,
    0x00,0x00, 0x08,0x02, 0x08,0x02, 0x08,0x42, 0xFF,0xCF, 0x08,0x02, 0x08,0x17, 0x0C,0x0A, 0x12,0x0A, 0x21,0x02,
    0x41,0x82, 0xFF,0x42, 0xC1,0xF2, 0x41,0x07, 0x41,0x04, 0x41,0x04, 0x42,0x08, 0x42,0x08, 0xFF,0xC8, 0x42,0x3C,
    0x00,0x00, 0x10,0x00, 0x7E,0x00, 0x53,0x00, 0xFF,0xC0, 0x52,0xF0, 0x52,0x38, 0x7E,0x18, 0x10,0x08, 0xFF,0x08,
    0x24,0x08, 0x18,0x18, 0xE6,0xD8, 0x98,0x70, 0x98,0x30, 0x98,0x30, 0x98,0x30, 0x98,0x20, 0xB8,0x60, 0xBF,0xE0,
    0x04,0x03, 0x06,0x03, 0x02,0x03, 0x02,0x01, 0x03,0x01, 0x01,0x01, 0x01,0x01, 0x00,0x81, 0x00,0x80, 0x00,0x80,
    0x00,0x40, 0x00,0x40, 0x00,0x20, 0x00,0x20, 0x00,0x20, 0x00,0x30, 0x00,0x10, 0x00,0x10, 0x00,0x18, 0x00,0x0F,
    0x9C,0x10, 0xC4,0x10, 0xC4,0x10, 0xC2,0x10, 0xC2,0x10, 0xC2,0x7F, 0xC7,0x80, 0xFC,0x00, 0xE1,0xE0, 0xF8,0x00,
    0xE0,0x1F, 0xE0,0x20, 0xE0,0x27, 0x70,0x24, 0x70,0x25, 0x70,0x25, 0x70,0x15, 0x38,0x15, 0x38,0x15, 0xFF,0xFF,
    0x42,0x0B, 0x42,0x09, 0x42,0x09, 0x42,0x09, 0x42,0x11, 0xFE,0x11, 0x01,0xF1, 0x00,0x0F, 0x03,0xC2, 0x00,0x32,
    0xFF,0x02, 0x01,0x02, 0xF9,0x02, 0x05,0x02, 0xF5,0x02, 0xF5,0x06, 0xF5,0x04, 0xF2,0x05, 0xF2,0x05, 0xFF,0xFD,
    0x31,0xE0, 0x30,0xE0, 0x30,0x40, 0x30,0x40, 0x30,0xC0, 0x7C,0xC0, 0x7F,0x80, 0x7F,0x80, 0x7F,0x80, 0x7F,0x80,
    0x7F,0x80, 0xFF,0x00, 0xFF,0x00, 0xFF,0x00, 0xFF,0x00, 0xFE,0x00, 0xFE,0x00, 0xFE,0x00, 0xFE,0x00, 0xFC,0x00,  
                                                                                                          
//DR.
    0x1F,0xF0, 0x3F,0xDC, 0x73,0xF6, 0x5F,0x82, 0x40,0x33, 0x8C,0x19, 0x98,0x0D, 0xB4,0x11, 0xC0,0x41, 0x47,0xE3,
    0x66,0xB2, 0x6F,0xFA, 0x2E,0x3A, 0x3C,0x2E, 0x7E,0x3F, 0x53,0x45, 0x51,0xC5, 0x71,0xC7, 0x33,0xCE, 0x7F,0xFF,       
                                                                                                          
//Dr. House(3x2)
    0x00,0x3F, 0x00,0x3A, 0x00,0x28, 0x00,0x46, 0x00,0x52, 0x00,0xA9, 0x00,0xA4, 0x01,0xA3, 0x01,0x41, 0x01,0x00,
    0x02,0x00, 0x04,0xC0, 0x04,0xBF, 0x09,0x0D, 0x0A,0x15, 0x32,0x17, 0x42,0x00, 0x8C,0x1F, 0x88,0x00, 0xFF,0xFF,
    0xFF,0xFC, 0x22,0x22, 0x00,0x01, 0x8A,0x8A, 0x00,0x00, 0xA2,0x22, 0x40,0x00, 0x2A,0xAA, 0xB0,0x00, 0xCA,0x22,
    0x66,0x00, 0x31,0x8A, 0x08,0x80, 0x04,0x62, 0x02,0x30, 0x81,0x8E, 0x00,0xC3, 0x00,0x20, 0x00,0x13, 0xFF,0xFE,
    0x00,0x00, 0x00,0x00, 0x00,0x00, 0xC0,0x00, 0x60,0x00, 0x30,0x00, 0x08,0x00, 0xAE,0x00, 0x01,0x80, 0x22,0x40,
    0x00,0x20, 0x8A,0x98, 0x00,0x0E, 0x22,0x23, 0x00,0x7F, 0xBF,0x83, 0xE0,0x1C, 0x01,0xE4, 0xFE,0x08, 0x00,0x08,
    0x08,0x00, 0x07,0xFF, 0x04,0x00, 0x04,0x00, 0x04,0x00, 0x04,0x00, 0x02,0x00, 0x03,0x3F, 0x01,0x20, 0x00,0xA7,
    0x00,0xAB, 0x00,0x8B, 0x00,0x8B, 0x00,0x8B, 0x00,0x89, 0x00,0x85, 0x00,0xE5, 0x00,0x1F, 0x00,0x00, 0x00,0x00,
    0x00,0x10, 0xFF,0xE0, 0x00,0x20, 0x00,0x20, 0x00,0x23, 0x00,0x22, 0x00,0x23, 0xE0,0x21, 0x38,0x21, 0xC4,0x21,
    0xE8,0x21, 0xE8,0x40, 0xE8,0x40, 0xE8,0x43, 0xE8,0x40, 0xE8,0x40, 0xE8,0x40, 0xE8,0x40, 0x7E,0x4F, 0x01,0xF0,
    0x00,0x08, 0x00,0x08, 0x00,0x18, 0x00,0x10, 0xFE,0x10, 0x02,0x10, 0xF4,0x20, 0x34,0x20, 0x74,0x20, 0x74,0x40,
    0xFA,0x40, 0x02,0x40, 0x3E,0x40, 0xC0,0x80, 0x00,0x80, 0x00,0x80, 0x03,0x80, 0x3C,0x00, 0xE0,0x00, 0x00,0x00,      
                                                                                                          
//Sleep
    0xBF,0xFD, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xE9,0xB7, 0xA0,0x05, 0xE0,0x07, 0xA0,0x05, 0x99,0x89, 0x84,0x31,
    0xFF,0xFF, 0x80,0x01, 0xBF,0xFD, 0xEA,0xAB, 0xC4,0x45, 0xAA,0xAB, 0xD1,0x15, 0xAA,0xAB, 0xFF,0xFD, 0xC0,0x03,       
                                                                                                          
//Office (4x2)
    0x00,0x00, 0x00,0xFF, 0x01,0xC4, 0x02,0xEA, 0x04,0x3F, 0x0A,0x3E, 0x10,0x14, 0x1A,0xAA, 0x20,0x05, 0x62,0x23,
    0x82,0x21, 0xAB,0xE8, 0x82,0x20, 0xA2,0x22, 0x82,0xE0, 0xAA,0x2A, 0x83,0xE0, 0xA2,0x22, 0x80,0x00, 0xA8,0xA8,
    0x00,0x00, 0xF0,0x00, 0x78,0x00, 0xFC,0x00, 0x12,0x00, 0xAB,0x00, 0x44,0x80, 0xAA,0xC0, 0x17,0xE0, 0xFF,0xF0,
    0x80,0x08, 0xFF,0xFC, 0xD5,0x58, 0xAA,0xA8, 0xD7,0xD8, 0xAB,0xE8, 0xD5,0x58, 0xAA,0xA8, 0xD5,0x58, 0xAA,0xA8,     
                                                                                                          
//Smile
    0x00,0x00, 0x00,0x00, 0x03,0xE0, 0x0C,0x18, 0x10,0x04, 0x20,0x02, 0x20,0x02, 0x42,0x21, 0x40,0x01, 0x40,0x01,
    0x40,0x01, 0x48,0x09, 0x48,0x09, 0x24,0x12, 0x23,0xE2, 0x10,0x04, 0x0C,0x18, 0x03,0xE0, 0x00,0x00, 0x00,0x00,       
                                                                                                      
    0x00,0x00, 0x00,0x07, 0x00,0x38, 0x00,0xF7, 0x03,0x22, 0x02,0x22, 0x02,0x72, 0x02,0xD3, 0x02,0x56, 0x02,0x52,
    0x02,0x52, 0x02,0xF4, 0x02,0x08, 0x02,0x00, 0x02,0x00, 0x02,0xA8, 0x02,0x00, 0x02,0x22, 0x01,0xFF, 0x00,0x00,
    0x80,0x00, 0xA2,0x22, 0x00,0x00, 0xE0,0x40, 0x4F,0xFD, 0x49,0x25, 0x42,0x20, 0x4C,0xBC, 0xE0,0x80, 0x47,0xE0,
    0x41,0x20, 0x42,0x24, 0x4C,0x3D, 0x03,0xE0, 0x05,0xD0, 0xA9,0xC8, 0x09,0xC8, 0x29,0xCA, 0x99,0xC8, 0xFF,0xFF,
    0xD5,0x5C, 0xFF,0xFF, 0x64,0x44, 0x08,0x2A, 0xFF,0xBF, 0x00,0xBF, 0xFF,0x04, 0x22,0x2A, 0xFF,0x31, 0x08,0x2F,
    0xFF,0x35, 0x08,0x2A, 0xFF,0xB5, 0x00,0x2A, 0x00,0x35, 0xA8,0xAA, 0x00,0x35, 0x22,0x2A, 0x00,0x35, 0xFF,0xFF,
    0x00,0x00, 0xF8,0x00, 0x44,0x00, 0xAB,0x00, 0xD1,0x80, 0xFE,0xE0, 0xFC,0x50, 0xAF,0xEC, 0x17,0xF3, 0xFF,0xFC,
    0x7D,0x58, 0xAE,0xA8, 0x65,0x58, 0xBE,0xA8, 0x55,0x58, 0xAA,0xA8, 0x55,0x58, 0xAA,0xA8, 0x7F,0xF8, 0xC0,0x00, 
                                                                                                          
//Chemical
    0x00,0x00, 0x00,0x00, 0x00,0x00, 0x07,0xE0, 0x04,0x20, 0x04,0x60, 0x02,0x40, 0x02,0x40, 0x02,0x40, 0x04,0x40,
    0x08,0x20, 0x10,0x10, 0x1D,0xF8, 0x1D,0xF8, 0x1F,0xF8, 0x1F,0xF0, 0x0F,0xF0, 0x07,0xE0, 0x03,0x80, 0x00,0x00,       
                                                                                                          
//Rich House(3x3)
    0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00,
    0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0xFF, 0x3F,0x22, 0x40,0x00, 0x6F,0xAA,
    0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x01, 0x00,0x0F, 0x00,0x0F, 0x00,0x0F,
    0x00,0x1F, 0x00,0x1F, 0x00,0x1F, 0x00,0x1F, 0x00,0x1F, 0x00,0x3F, 0xC0,0x3F, 0x3F,0xFF, 0x00,0x7F, 0xAA,0xAF,
    0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x1F,0xE0, 0xFF,0xD8, 0xFF,0xAC, 0xFF,0xD4, 0xFF,0xA8,
    0xFF,0x58, 0xFF,0xA8, 0xFF,0x58, 0xFF,0xB0, 0xFF,0x50, 0xFE,0xB0, 0xFF,0x60, 0xFE,0xA0, 0xFD,0x60, 0xFE,0xA0,
    0x60,0x00, 0x7E,0x22, 0x23,0x80, 0x3A,0x8A, 0x20,0x00, 0x3A,0x22, 0x30,0x00, 0x3A,0xAA, 0x10,0x00, 0x12,0x22,
    0x10,0xFC, 0x1F,0x0F, 0x11,0x0C, 0x11,0x0C, 0x11,0x0C, 0x08,0x8C, 0x08,0x88, 0x08,0x88, 0x0F,0xFF, 0x78,0x00,
    0x00,0x00, 0x22,0x22, 0x00,0x00, 0x8A,0x8A, 0x00,0x01, 0x22,0x23, 0x00,0x01, 0xAA,0xAB, 0x00,0x01, 0x22,0x23,
    0x00,0x03, 0xFA,0x8B, 0x37,0x03, 0x20,0xFF, 0x20,0x87, 0x20,0x87, 0x20,0x87, 0x21,0x07, 0xA1,0x07, 0xFF,0x0F,
    0xFD,0x40, 0xFE,0xC0, 0xFD,0x70, 0xFA,0xCC, 0xFD,0x42, 0xFA,0xE2, 0xFD,0x82, 0xFA,0xAA, 0xF5,0x84, 0xFA,0xA4,
    0xF5,0x84, 0xEB,0x8C, 0xF5,0x0C, 0xEB,0x22, 0xF5,0x01, 0xEA,0xAB, 0xD6,0x01, 0xEB,0xA3, 0xD6,0x71, 0xEE,0x4B,
    0x80,0x00, 0x80,0x00, 0x9F,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0x3F,0xFF, 0x11,0xC0, 0x11,0x00, 0x11,0x00, 0x11,0x7F,
    0x11,0x40, 0x11,0x7F, 0x11,0x44, 0x12,0x44, 0x12,0x44, 0x12,0x44, 0x12,0x44, 0x12,0x44, 0x7F,0xFF, 0x00,0x00,
    0x03,0xFF, 0x00,0x0F, 0xC0,0x0F, 0xFE,0x3F, 0xFF,0xCF, 0xFF,0xCF, 0x18,0xCF, 0x08,0xBF, 0x08,0x8F, 0xE8,0x8F,
    0x29,0x0F, 0xE9,0x0F, 0x69,0x0F, 0x69,0x1F, 0x49,0x1F, 0x4A,0x1F, 0x4A,0x1F, 0x4F,0xFE, 0xFF,0xFF, 0x01,0xFF,
    0xD4,0x4F, 0xAC,0x89, 0xD4,0x91, 0xAC,0x91, 0xD8,0x93, 0xBF,0xFF, 0x7F,0xFF, 0xC0,0x01, 0x40,0x3D, 0xDD,0x81,
    0x43,0x79, 0xC0,0x01, 0x47,0x3D, 0xC0,0x01, 0x7F,0xFF, 0xBA,0x38, 0x52,0x38, 0xB2,0x30, 0xFA,0x30, 0xFB,0xF0,                                                                                                       
//Error (39)(0x27)
    0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00,
    0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00,       
                                                                                                          
//Rapid(3x2)
    0x00,0x00, 0x00,0x01, 0x00,0x03, 0x00,0x3F, 0x00,0x7F, 0x00,0xFF, 0x00,0x01, 0x00,0x00, 0x00,0x1F, 0x00,0xF8,
    0x01,0x90, 0x01,0x17, 0x01,0x38, 0x01,0x17, 0x01,0x98, 0x00,0xB7, 0x00,0x92, 0x00,0x92, 0x00,0x95, 0x01,0x78,
    0xFC,0x00, 0xC0,0x00, 0xBF,0x00, 0xFF,0x80, 0xE3,0xFF, 0xC7,0xFE, 0xFF,0xFD, 0xFD,0xC0, 0x03,0x80, 0x3F,0x00,
    0x84,0xFE, 0xF2,0xBA, 0xA4,0x10, 0xF2,0x7C, 0xA0,0x54, 0xE6,0x7C, 0x82,0x54, 0xF2,0xFE, 0x85,0x11, 0xF4,0xFF,
    0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0xE0,0x00, 0x30,0x00, 0x3C,0x00, 0x3E,0x00,
    0x7F,0x00, 0x7F,0xC0, 0x7F,0xE0, 0x7F,0xF0, 0xFF,0xF0, 0xFF,0xE0, 0xFF,0xE0, 0xFF,0xE0, 0xFF,0xC0, 0xFF,0xC0,
    0x02,0xC0, 0x02,0x7F, 0x0A,0x53, 0x14,0x32, 0x14,0x12, 0x14,0x12, 0x24,0x12, 0x24,0x12, 0x24,0x12, 0x44,0x12,
    0x44,0x12, 0x22,0x12, 0x21,0x92, 0x02,0x5F, 0x1E,0x70, 0x08,0x5F, 0x08,0x40, 0x08,0x7F, 0x0C,0x40, 0x01,0xFF,
    0x3C,0xF1, 0xE7,0x9F, 0xE4,0x90, 0x24,0x90, 0x27,0x9E, 0xE7,0x9E, 0xE7,0x9E, 0xE7,0x9E, 0xE7,0x9E, 0xE7,0x9C,
    0xE7,0x9C, 0xE7,0x9C, 0xE7,0x9C, 0xFF,0xFF, 0x00,0x00, 0xFF,0x0B, 0x00,0x0A, 0xFC,0x0A, 0x00,0x0A, 0xFF,0xFF,
    0xFF,0xC0, 0xFF,0x80, 0x3C,0x80, 0x38,0x40, 0x38,0x38, 0x70,0x24, 0x70,0x24, 0x70,0x24, 0x60,0x24, 0x60,0x24,
    0x40,0x24, 0x80,0x24, 0x80,0x44, 0xC0,0x44, 0x40,0x44, 0x60,0xC4, 0x10,0xFC, 0x0E,0xA0, 0x0B,0xE0, 0xFD,0xE0,      
                                                                                                          
//Door Close
    0xFF,0xFF, 0xAB,0xEA, 0x55,0x75, 0xAB,0x6A, 0x55,0x75, 0xAB,0x6A, 0x55,0x75, 0xAB,0x6A, 0x55,0x75, 0xAB,0x6A,
    0x55,0x75, 0xAB,0x6A, 0x55,0x75, 0xFF,0x7F, 0x01,0x60, 0x01,0x60, 0x01,0x60, 0x01,0x60, 0x01,0x60, 0x01,0xE0,       
                                                                                                          
//Door Open
    0xFF,0xFF, 0xAB,0xEA, 0x56,0xD5, 0xAD,0x6A, 0x5A,0x55, 0xBC,0x6A, 0x68,0x55, 0xA8,0x6A, 0x68,0x55, 0xA8,0x6A,
    0x68,0x55, 0xA8,0x6A, 0x68,0x55, 0xE8,0x7F, 0x28,0x80, 0x29,0x00, 0x2A,0x00, 0x3C,0x00, 0x00,0x00, 0x00,0x00,       
                                                                                                          
//Stair1
    0x00,0x00, 0x00,0x00, 0x00,0x00, 0x01,0xFF, 0x01,0x80, 0x01,0x40, 0x01,0x20, 0x0F,0x1F, 0x0C,0x95, 0x0A,0x5A,
    0x09,0x35, 0x78,0xFA, 0x64,0xD5, 0x52,0xAA, 0x49,0xD5, 0x47,0xAA, 0x45,0x55, 0x26,0xAA, 0x15,0x55, 0x0E,0xAA,       
                                                                                                          
//Stair2
    0x00,0x00, 0x00,0x00, 0x00,0x00, 0xFF,0x80, 0x01,0x80, 0x02,0x80, 0x04,0x80, 0xF8,0xF0, 0xA9,0x30, 0x5A,0x50,
    0xAC,0x90, 0x5F,0x1E, 0xAB,0x26, 0x55,0x4A, 0xAB,0x92, 0x55,0xE2, 0xAA,0xA2, 0x55,0x64, 0xAA,0xA8, 0x55,0x70,       
                                                                                                          
//Flower
    0x00,0x60, 0x00,0xF0, 0x00,0x90, 0x30,0x90, 0x38,0xB0, 0x2C,0xE0, 0x25,0xC0, 0x13,0x00, 0x0B,0x00, 0x0F,0xE0,
    0x37,0x58, 0x6B,0xAC, 0x77,0x5C, 0x4F,0xE4, 0x70,0x1C, 0x2F,0xE8, 0x20,0x08, 0x10,0x10, 0x10,0x10, 0x0F,0xE0,       
                                                                                                          
//Home (2x2)
    0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0xFF, 0x01,0x44, 0x03,0xAA, 0x02,0x91,
    0x05,0xEA, 0x05,0x44, 0x0A,0xEA, 0x16,0x31, 0x14,0xBA, 0x3E,0x34, 0x58,0xBA, 0xFA,0x39, 0xF8,0x8E, 0x4A,0x26,
    0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0xFF,0xC0, 0x44,0x40, 0xAA,0xA0, 0x11,0x20,
    0xAA,0xB0, 0x44,0x50, 0xAA,0xA8, 0x11,0x18, 0xAA,0xAC, 0x44,0x44, 0xAA,0xAA, 0x11,0x12, 0xAA,0xAB, 0x44,0x45,
    0x08,0x8F, 0x0A,0x23, 0x08,0x88, 0x0A,0x22, 0x08,0x88, 0x0B,0xE2, 0x09,0x38, 0x0B,0x12, 0x09,0x18, 0x0B,0x12,
    0x05,0x18, 0x07,0x12, 0x05,0x18, 0x07,0x12, 0x05,0x18, 0x07,0x12, 0x01,0x18, 0x00,0xF2, 0x00,0x1C, 0x00,0x03,
    0xAA,0xFE, 0xFF,0xD6, 0xAA,0xBA, 0xDD,0x76, 0xB6,0xDA, 0xD5,0x56, 0xB6,0xFA, 0xDD,0x56, 0xAA,0xAA, 0xD5,0x56,
    0xAA,0xAA, 0xD5,0x56, 0xAA,0xAA, 0xD5,0x56, 0xAA,0xAB, 0xD5,0x55, 0xEA,0xAB, 0x55,0x7F, 0xEF,0xC0, 0xF8,0x00, 
                                                                                                          
//Table
    0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0xFF,0xFF, 0xAA,0xAB, 0xD5,0x55, 0xAA,0xAB, 0xD5,0x55, 0xAA,0xAB,
    0xD5,0x55, 0xFF,0xFF, 0x80,0x01, 0xFF,0xFF, 0x54,0x2A, 0x5C,0x3A, 0x50,0x0A, 0x50,0x0A, 0x50,0x0A, 0x70,0x0E,       
                                                                                                          
//Cabinet
    0xFF,0xFF, 0xA0,0x06, 0x60,0x05, 0xA0,0x06, 0x60,0x05, 0xBF,0xFE, 0x60,0x05, 0xAF,0xF6, 0x68,0x15, 0xA9,0x96,
    0x68,0x15, 0xAF,0xF6, 0x60,0x05, 0xEF,0xF7, 0x28,0x14, 0x29,0x94, 0x28,0x14, 0x2F,0xF4, 0x20,0x04, 0x3F,0xFC,       
                                                                                                          
//Girl 
    0x0F,0xFC, 0x1B,0xFE, 0x39,0xFE, 0x30,0x7F, 0x20,0x1F, 0x40,0x1F, 0x44,0x27, 0x20,0x01, 0x20,0x02, 0x22,0x22,
    0x51,0xC5, 0x6E,0x1F, 0xC7,0xF1, 0x0C,0x18, 0x14,0x14, 0x14,0x14, 0x14,0x14, 0x1C,0x1C, 0x07,0xF0, 0x0F,0x38,       
                                                                                                          
//Bed
    0xDF,0xFB, 0xA0,0x05, 0xA0,0x05, 0xA0,0x05, 0xA0,0x05, 0x9F,0xF9, 0xBF,0xFD, 0xC0,0x03, 0x80,0x01, 0xBF,0xFD,
    0xC4,0x47, 0xAA,0xAB, 0x91,0x11, 0xAA,0xAB, 0xC4,0x45, 0xAA,0xAB, 0x91,0x11, 0xAA,0xAB, 0xFF,0xFD, 0xC0,0x03,       
                                                                                                          
//Police
    0x0F,0xE0, 0x70,0x18, 0x80,0x04, 0x80,0x14, 0x9F,0xCE, 0xC0,0x0A, 0x7F,0xFB, 0x80,0x01, 0x80,0x02, 0xC0,0x02,
    0x63,0x84, 0x20,0x08, 0x1F,0xF0, 0x22,0x8C, 0x41,0x03, 0x8D,0x6D, 0xB1,0x0B, 0xDF,0xF8, 0x1F,0xF8, 0x3F,0x7C,       
                                                                                                          
//Slingshot
    0x00,0x00, 0x00,0x00, 0x60,0x30, 0x90,0x48, 0xF8,0x7C, 0xFC,0x7C, 0xBC,0x6C, 0x96,0x4E, 0xB3,0x6A, 0x91,0xCB,
    0xA8,0xE9, 0x8F,0xE9, 0x62,0x71, 0x28,0xBB, 0x12,0x4E, 0x18,0xC0, 0x12,0x40, 0x18,0xC0, 0x1A,0xC0, 0x0F,0x80,       
                                                                                                          
//Ticket Machine
    0xFF,0xFF, 0xA0,0x06, 0x60,0x05, 0xA0,0x06, 0x60,0x05, 0xBF,0xFE, 0x7F,0xFD, 0xB0,0x0E, 0x76,0xCD, 0xB0,0x0E,
    0x75,0x6D, 0xB0,0x0E, 0x77,0xED, 0xFF,0xFF, 0x31,0x0C, 0x3F,0xFC, 0x3B,0x9C, 0x3F,0xFC, 0x31,0x0C, 0x3F,0xFC,       
                                                                                                          
//Money
    0x00,0x00, 0x00,0x00, 0x00,0x0C, 0x00,0x1E, 0x00,0x37, 0x00,0x7B, 0x00,0xDD, 0x03,0xA2, 0x0F,0x61, 0x3A,0xA2,
    0xF7,0x57, 0x7B,0xEE, 0x35,0x78, 0x1B,0xB0, 0x0D,0xE0, 0x07,0xC0, 0x03,0x80, 0x00,0x00, 0x00,0x00, 0x00,0x00,       
                                                                                                          
//Ticket
    0x00,0x00, 0x3F,0xF8, 0x2A,0xB8, 0x2A,0xB8, 0x2B,0xF8, 0x2B,0xF8, 0x2A,0x38, 0x2A,0x38, 0x2A,0x38, 0x2A,0x38,
    0x2A,0x38, 0x2A,0x38, 0x2A,0x38, 0x2B,0x38, 0x2C,0xB8, 0x22,0xB8, 0x22,0xB8, 0x22,0xB8, 0x3F,0xF8, 0x00,0x00,       
                                                                                                          
//Cellphone
    0x00,0x00, 0x18,0x00, 0x18,0x00, 0x18,0x00, 0x3F,0x80, 0x20,0x60, 0x2F,0x90, 0x30,0x50, 0x30,0x30, 0x30,0x30,
    0x30,0x30, 0x2F,0xD0, 0x20,0x10, 0x2D,0x50, 0x20,0x10, 0x2D,0x50, 0x20,0x10, 0x2D,0x50, 0x18,0x60, 0x0F,0xC0,       
                                                                                                          
//Streetlamp
    0x01,0x00, 0x03,0x80, 0x05,0x40, 0x0F,0xE0, 0x04,0x40, 0x04,0x40, 0x03,0x80, 0x01,0x00, 0x01,0x00, 0x01,0x00,
    0x01,0x00, 0x01,0x00, 0x01,0x00, 0x01,0x00, 0x01,0x00, 0x01,0x00, 0x01,0x00, 0x03,0x80, 0x07,0xC0, 0x0F,0xE0,       
                                                                                                          
//Invoice
    0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x7F,0xE0, 0x40,0x30, 0x40,0x28, 0x5E,0x3C, 0x40,0x04, 0x4B,0xC4,
    0x40,0x04, 0x5D,0xD4, 0x40,0x04, 0x47,0xE4, 0x58,0x04, 0x40,0x04, 0x40,0x74, 0x40,0x04, 0x7F,0xFC, 0x00,0x00,       
                                                                                                          
//Computer
    0x1F,0xFC, 0x18,0x0C, 0x14,0x14, 0x13,0xE4, 0xF2,0x27, 0xB2,0x27, 0xD3,0xF5, 0xBF,0xFF, 0xC6,0x31, 0xAC,0x1B,
    0xDB,0xED, 0xFF,0xFF, 0x80,0x01, 0xFF,0xFF, 0x54,0x2A, 0x5C,0x3A, 0x50,0x0A, 0x50,0x0A, 0x50,0x0A, 0x70,0x0E,       
                                                                                                          
//CC800
    0x0C,0x00, 0x0F,0x00, 0x0B,0xC0, 0x08,0xF0, 0x0B,0x3C, 0x0A,0xCF, 0x0A,0x33, 0x09,0x0D, 0x16,0xC5, 0x27,0xB5,
    0x38,0xED, 0x42,0x39, 0x90,0x8F, 0xC4,0x25, 0xF1,0x0F, 0x3C,0x5E, 0x0F,0x3C, 0x03,0xF8, 0x00,0xF0, 0x00,0x60,       
                                                                                                          
//Water
    0x05,0x18, 0x0A,0x2C, 0x1C,0x46, 0x78,0x8B, 0x51,0x11, 0x62,0x23, 0xC4,0x45, 0x88,0x8B, 0x91,0x14, 0xA2,0x24,
    0xC4,0x46, 0x68,0x8B, 0x31,0x11, 0x22,0x3B, 0x64,0x7F, 0x68,0xAE, 0x71,0xE0, 0x3B,0x80, 0x1F,0x00, 0x00,0x00,       
                                                                                                          
//Cabinet Open
    0xFF,0xFF, 0xA0,0x05, 0x60,0x06, 0xA0,0x05, 0x60,0x06, 0xBF,0xFD, 0x60,0x06, 0xAF,0xF5, 0x6D,0x6A, 0xAA,0xA4,
    0x6D,0x62, 0xAF,0xF2, 0x60,0x0A, 0xEF,0xF6, 0x2D,0x6A, 0x2A,0xA4, 0x2D,0x62, 0x2F,0xF2, 0x20,0x0A, 0x3F,0xFE,       
                                                                                                          
//Bad Man Left  
    0x07,0xF0, 0x1F,0xFC, 0x3F,0xFE, 0x71,0xFE, 0xE0,0x5F, 0xFF,0xFF, 0x7D,0xEF, 0x3D,0xCE, 0x10,0x0C, 0x10,0x38,
    0x1F,0xD8, 0x04,0x24, 0x0C,0x24, 0x14,0x24, 0x13,0xE4, 0x16,0xBC, 0x1D,0xD8, 0x06,0xA8, 0x05,0xD8, 0x1F,0xFC,       
                                                                                                          
//Bad Man Right  
    0x0F,0xE0, 0x3F,0xF8, 0x7F,0xFC, 0x7F,0x8E, 0xFA,0x07, 0xFF,0xFF, 0xF7,0xBE, 0x73,0xBC, 0x30,0x08, 0x1C,0x08,
    0x1B,0xF8, 0x24,0x20, 0x24,0x30, 0x24,0x28, 0x27,0xC8, 0x3D,0x68, 0x1B,0xB8, 0x15,0x60, 0x1B,0xA0, 0x3F,0xF8,       
                                                                                                          
//Rapid
    0xFF,0x98, 0x81,0x58, 0x00,0xB8, 0x00,0x98, 0x00,0x68, 0x30,0x54, 0x48,0x4A, 0x48,0x45, 0x48,0x63, 0x48,0x71,
    0x48,0x79, 0x48,0x7D, 0x48,0x7F, 0x48,0x7F, 0x30,0x7F, 0x00,0x7F, 0x00,0x5F, 0x00,0x4F, 0xFF,0xE7, 0x80,0x13,
    0x40,0x09, 0xFF,0xE5, 0x00,0x53, 0x00,0x49, 0x30,0x65, 0x48,0x63, 0x48,0x71, 0x48,0x79, 0x48,0x7D, 0x48,0x7F,
    0x48,0x7F, 0x48,0x7F, 0x48,0x7F, 0x30,0x7F, 0x00,0x5F, 0x00,0x4F, 0xFF,0xE7, 0x40,0x13, 0x20,0x09, 0xFF,0xE5,
    0x00,0x53, 0x00,0x49, 0x30,0x45, 0x48,0x63, 0x48,0x71, 0x48,0x79, 0x48,0x7D, 0x48,0x7F, 0x48,0x7F, 0x48,0x7F,
    0x48,0x7F, 0x30,0x5F, 0x00,0x4F, 0xFF,0xC7, 0x80,0x23, 0x40,0x11, 0x27,0x89, 0x13,0xC5, 0x09,0xE3, 0x07,0xFF,   
                                                                                                          
//Track
    0x51,0x98, 0xB1,0x98, 0x51,0x98, 0xB1,0x98, 0x51,0x98, 0xB1,0x98, 0x51,0x98, 0xB1,0x98, 0x51,0x98, 0xB1,0x98,
    0x51,0x98, 0xB1,0x98, 0x51,0x98, 0xB1,0x98, 0x51,0x98, 0xB1,0x98, 0x51,0x98, 0xB1,0x98, 0x51,0x98, 0xB1,0x98,       
                                                                                                          
//Closestool 
    0x07,0xE0, 0x08,0x10, 0x13,0xC8, 0x24,0x24, 0x24,0x24, 0x24,0x24, 0x24,0x24, 0x24,0x24, 0x13,0xC8, 0x08,0x10,
    0x0F,0xF0, 0x10,0x08, 0x27,0xE4, 0x27,0xE4, 0x30,0x0C, 0x2F,0xF4, 0x10,0x08, 0x10,0x08, 0x0F,0xF0, 0x1F,0xF8,       
                                                                                                          
//Toilet paper 
    0x00,0x00, 0x00,0x18, 0x00,0xE8, 0x03,0x04, 0x1C,0x04, 0x60,0x02, 0x40,0x02, 0x20,0x01, 0x60,0x06, 0x50,0x7B,
    0x73,0x9F, 0x6C,0xED, 0x37,0x36, 0x78,0xD8, 0x73,0x63, 0x3D,0xBC, 0x37,0xC0, 0x1C,0x00, 0x08,0x00, 0x00,0x00,       
                                                                                                          
//Sad
    0x00,0x00, 0x00,0x00, 0x03,0xE0, 0x0C,0x18, 0x10,0x04, 0x20,0x02, 0x20,0x02, 0x42,0x21, 0x40,0x01, 0x40,0x01,
    0x40,0x01, 0x43,0xE1, 0x44,0x11, 0x28,0x0A, 0x20,0x02, 0x10,0x04, 0x0C,0x18, 0x03,0xE0, 0x00,0x00, 0x00,0x00,       
                                                                                                          
//Asistant
    0x03,0xC0, 0x0F,0xF0, 0x1E,0x30, 0x1C,0x18, 0x30,0x0C, 0x72,0x26, 0x20,0x08, 0x20,0x08, 0x19,0xC8, 0x08,0x10,
    0x07,0xF8, 0x1F,0x5E, 0x23,0xD1, 0x4F,0xDF, 0xBF,0xF0, 0x4F,0xD0, 0x07,0x30, 0x0F,0x98, 0x1F,0xC4, 0x1E,0x7C
};

//----------------------------------------------------------------
//int CheckStatus(void);
//void DrawGraphic(int x, int y, int iObjectID);
//void DrawMap(void);
//void DisplayMessage(int iObjectID, char *sMessage);
//int IsWalkable(void);
//void Talk(void);
//void Search(void);
//int DisplayMenu(int x, int y, char sItems[][11], unsigned char *caObject, int iItemCount);
//void RapidMove(void);
//void RapidBack(void);
//----------------------------------------------------------------
int max_ThingCount;
char mem_ThingBox[10];
char str_ThingBox[10][11];

char str_MenuItem[3][11] =
{
    "Talk      ",
    "Find      ",
    "Use Item  "
};

int cnt_MenuItem;
int g_iStory;
int man_x, man_y;
int map_x, map_y;
int rec_x, rec_y;
int rec_man_x, rec_man_y;
int rec_map_x, rec_map_y;
//----------------------------------------------------------------
//----------------------------------------------------------------
void DrawGraphic(int x, int y, int iObjectID)
{
    WriteBlock(x *16, y *20, 16, 20, WB_COPY, GraphicData[iObjectID]); //fix.
}

//ռ䲻㣬ʱΪ
//void DrawMap(int iMapX, int iMapY, int iManX, int iManY)
void DrawMap()
{
    char x, y;
    for (y = 0; y < LCD_MAX_HEIGHT_OBJ; y = y + 1)
    {
        for (x = 0; x < LCD_MAX_WIDTH_OBJ; x = x + 1)
        {
            DrawGraphic(x, y, MapData[map_y + y][map_x + x]);
        }
    }
}

//----------------------------------------------------------------
void RapidMove()
{
    man_y = 4;

    map_x = 0;
    map_y = 15;
    DrawMap();
    Refresh();
    Delay(DELAY_TIME);

    MapData[15][0] = 73;
    MapData[16][0] = 74;
    MapData[17][0] = 75;
    MapData[18][0] = 76;
    DrawMap();
    Refresh();
    Delay(DELAY_TIME);

    MapData[15][0] = 74;
    MapData[16][0] = 75;
    MapData[17][0] = 76;
    DrawMap();
    Refresh();
    Delay(DELAY_TIME);

    MapData[15][0] = 75;
    MapData[16][0] = 76;
    DrawMap();
    Refresh();
    Delay(DELAY_TIME);

    MapData[15][0] = 76;
    DrawMap();
    Refresh();
    Delay(DELAY_TIME);
}

//----------------------------------------------------------------
void RapidBack()
{
    MapData[15][0] = 76;
    MapData[16][0] = 76;
    MapData[17][0] = 76;
    MapData[18][0] = 76;
    DrawMap();
    Refresh();
    Delay(DELAY_TIME);

    MapData[15][0] = 75;
    DrawMap();
    Refresh();
    Delay(DELAY_TIME);

    MapData[15][0] = 74;
    MapData[16][0] = 75;
    DrawMap();
    Refresh();
    Delay(DELAY_TIME);

    MapData[15][0] = 73;
    MapData[16][0] = 74;
    MapData[17][0] = 75;
    DrawMap();
    Refresh();
    Delay(DELAY_TIME);

    MapData[15][0] = 76;
    MapData[16][0] = 73;
    MapData[17][0] = 74;
    MapData[18][0] = 75;
    DrawMap();
    Refresh();
    Delay(DELAY_TIME);
}

//----------------------------------------------------------------
void DisplayMessage(int iObjectID, addr sMessage)
{
    char x0, f_end;
    char i, n, ch[3];

    Block(1, LCD_H-20, LCD_W-1, LCD_H-1, 0);//fix.
    Rectangle(20, LCD_H-20, LCD_W-1, LCD_H-1, 1);//fix.
    WriteBlock(0 *16, LCD_H-20, 16, 20, WB_COPY, GraphicData[iObjectID]); //fix.
    //DrawGraphic(0, LCD_HEIGHT_END, iObjectID);

    ch[2] = 0;
    f_end = 0;
    x0 = 24;
    for (;;)
    {
        for (n=0; n<20; n++)
        {
            ch[0] = *(sMessage+n);
            if (ch[0] == 0)
            {
                f_end = 1;
                break;
            }
            if (ch[0] & 0x80)
            {
                n = n + 2;
                break;
            }
            if (ch[0] == ' ')
            {
                if (n == 0)
                {
                    sMessage++;
                    n--;
                    continue;
                }
                n++;
                break;
            }
        }
        if (x0 > 24+6*21-6*n)
        {
            TextOut(24+6*20, LCD_H-16, ">>", WB_COPY);
            Refresh();
            getchar();
            Block(24, LCD_H-16, 23+6*22, LCD_H-5, 0);
            x0 = 24;
        }
        if (*sMessage != 0)
        {
            for(i=0; i<n; i++)
            {
                ch[0] = *sMessage++;
                ch[1] = 0;
                if (ch[0] & 0x80)
                {
                    ch[1] = *sMessage++;
                    i++;
                }
                TextOut(x0, LCD_H-16, ch, WB_COPY);
                Refresh();
                if (ch[1] == 0)
                {
                    x0 = x0 + 6;
                    Delay(25);
                }
                else
                {
                    x0 = x0 + 12;
                    Delay(50);
                }
            }
        }
        if (f_end != 0)
        {
            getchar();
            break;
        }
    }
}

//----------------------------------------------------------------
int DisplayMenu(addr sItems, addr caObject, int iItemCount) //
{
    int i, iBase, iThingIndex, x_dot, y_dot, iSelected, iTemp;
    int ch;

    iBase = 0;
    iSelected = 0;

    while (1)
    {
        Block(30, 19, 112, 79, 0);//fix.
        //Rectangle(30, 19, 112, 79, 1);//fix.
        for (i = 0; i < 3; i++)
        {
            iThingIndex = iBase + i;
            if (iThingIndex < iItemCount)
            {
                if (caObject != NULL)
                {
                    DrawGraphic(2, i + 1, *(caObject + iThingIndex));
                    x_dot = 50;
                }
                else
                {
                    x_dot = 34;
                }
                y_dot = (i + 1) *20+4;
                TextOut(x_dot, y_dot, sItems + iThingIndex * 11, WB_COPY);
            }
            else
            {
                break;
            }
        }
        iTemp = (iSelected + 1) *20+2;
        Block(x_dot, iTemp, x_dot + 5 * 12 - 1, iTemp + 15, WB_NOT);//fix.
        Rectangle(30, 19, 112, 79, 1);//fix.
        Refresh();
        ch = getchar();
        if (ch == KEY_UP || ch=='w')
        {
            if (iSelected > 0)
            {
                iSelected--;
            }
            else
            {
                if (--iBase < 0)
                {
                	if (iItemCount<3)
                	{
                		iBase = 0;
                		iSelected = iItemCount - 1;
                	}
                	else
                	{
                    	iBase = iItemCount - 3;
                    	iSelected = 2;
                    }
                }
            }
        }
        else if (ch == KEY_DOWN || ch=='s')
        {
            if (iSelected < 2 && iSelected < iItemCount - 1)
            {
                iSelected++;
            }
            else
            {
                if (++iBase > iItemCount - 3)
                {
                    iBase = 0;
                    iSelected = 0;
                }
            }
        }
        else if (ch == KEY_ENTER || ch=='k'|| ch=='.' || ch==KEY_F1)
        {
            break;
        }
        else if (ch == KEY_ESC || ch=='j' || ch=='p' || ch==KEY_F2)
        {
            return  - 1;
        }
        
    }
    return (iBase + iSelected);
}

//----------------------------------------------------------------
void PoliceSeekRichHouse()
{
    int iTempX, iTempY;
    int iMapX, iMapY;

    iMapX = map_x;
    iMapY = map_y;

    map_x = 0;
    map_y = 0;

    iTempY = man_y;
    man_y = 4;
    DrawMap();

    DisplayMessage(OBJ_POLICE, "How strange! I heard the alarm next door. I should go check it out!");

    MapData[2][1] = OBJ_DRHOUSE4;
    for (iTempX = 1; iTempX <= 5; iTempX = iTempX + 1)
    {
        DrawMap();
        DrawGraphic(iTempX, 3, OBJ_POLICE);
        Refresh();
        Delay(DELAY_TIME);
    }
    DrawMap();
    DrawGraphic(5, 2, OBJ_POLICE);
    Refresh();
    Delay(DELAY_TIME);
    DrawMap();
    Refresh();
    Delay(DELAY_TIME);

    //Police go away
    g_iStory = 30;
    man_y = iTempY;
    map_x = iMapX;
    map_y = iMapY;
}

//----------------------------------------------------------------
void BadManGoAway()
{
    int iMapX, iMapY;

    iMapX = map_x;
    iMapY = map_y;
    map_x = 21;
    map_y = 25;
    MapData[27][24] = OBJ_BLANK;
    MapData[27][23] = OBJ_BADMANL;
    DrawMap();
    Refresh();
    Delay(DELAY_TIME);

    DisplayMessage(OBJ_BADMANR, "What? The toilet is leaking! I'll investigate.");

    MapData[27][23] = OBJ_BLANK;
    MapData[26][23] = OBJ_BADMANL;
    DrawMap();
    Refresh();
    Delay(DELAY_TIME);

    MapData[26][23] = OBJ_BLANK;
    MapData[25][23] = OBJ_BADMANL;
    DrawMap();
    Refresh();
    Delay(DELAY_TIME);

    MapData[25][23] = OBJ_BLANK;
    MapData[22][26] = OBJ_BADMANL;
    map_x = iMapX;
    map_y = iMapY;
}

//----------------------------------------------------------------
void TheEnd()
{
    int x;

    ClearScreen();
    DisplayMessage(OBJ_BLANK, "-The End-");
    DisplayMessage(OBJ_MAN, "Wait, why is the story over?");
    DisplayMessage(OBJ_SAD, "No way, there's no more free space! (Original)");
    DisplayMessage(OBJ_MAN, "No, I rescued the Dr.! You've got to give me some kind of animation or something, right? Please?");
    DisplayMessage(OBJ_SMILE, "Okay!");

    ClearScreen();
    x = 1;
    DrawGraphic(x + 4, 1, OBJ_MAN);
    DrawGraphic(x + 5, 1, OBJ_DR);
    DisplayMessage(OBJ_DR, "Oh no, he's coming!");

    ClearScreen();
    x++;
    DrawGraphic(x, 1, OBJ_BADMANR);
    DrawGraphic(x + 4, 1, OBJ_MAN2);
    DrawGraphic(x + 5, 1, OBJ_DR);
    DisplayMessage(OBJ_BADMANR, "Stop! Don't run!");

    ClearScreen();
    x++;
    DrawGraphic(x, 1, OBJ_BADMANR);
    DrawGraphic(x + 4, 1, OBJ_MAN);
    DrawGraphic(x + 5, 1, OBJ_DR);
    DisplayMessage(OBJ_MAN, "Help! Help me!");

    ClearScreen();
    x++;
    DrawGraphic(x, 1, OBJ_BADMANR);
    DrawGraphic(x + 4, 1, OBJ_MAN2);
    DrawGraphic(x + 5, 1, OBJ_DR);
    DisplayMessage(OBJ_BADMANR, "Stop! Don't run!");
    DisplayMessage(OBJ_MAN, "Waaahhh! I don't want an ending like this!");

    ClearScreen();
    DisplayMessage(OBJ_SMILE, "-The End-");
    exit(0);
}

//----------------------------------------------------------------
void Thing_GetObjectName(char cThingID, addr sName)
{
    if (cThingID == OBJ_SLINGSHOT)
    {
        strcpy(sName, "Slingshot ");
    }
    else if (cThingID == OBJ_TICKET)
    {
        strcpy(sName, "Ticket    ");
    }
    else if (cThingID == OBJ_INVOICE)
    {
        strcpy(sName, "Receipt   ");
    }
    else if (cThingID == OBJ_CC800)
    {
        strcpy(sName, "CC800     ");
    }
    else if (cThingID == OBJ_TOILETPAPER)
    {
        strcpy(sName, "WC-Paper  ");
    }
    else
    {
        strcpy(sName, "Inoculum  ");
    }
}

//----------------------------------------------------------------
void Thing_Exchange(char cOldThingID, char cNewThingID)
{
    int i;

    for (i=0; i<max_ThingCount; i++)
    {
        if (mem_ThingBox[i] == cOldThingID)
        {
            mem_ThingBox[i] = cNewThingID;
            Thing_GetObjectName(cNewThingID, str_ThingBox[i]);
            break;
        }
    }
}

//----------------------------------------------------------------
int Thing_Add(char cThingID)
{
    int i;

    for (i = 0; i < max_ThingCount; i = i + 1)
    {
        if (mem_ThingBox[i] == cThingID)
        {
            return 0;
            //iResult=1;
            //break;
        }
    }
    //if (Thing_IsExist(cThingID))
    //{
    //    return 0;
    //}
    mem_ThingBox[max_ThingCount] = cThingID;
    Thing_GetObjectName(cThingID, str_ThingBox[max_ThingCount]);
    max_ThingCount++;
    return 1;
}

void BackupXY()
{
	rec_man_x = rec_x;
	rec_man_y = rec_y;
	rec_map_x = map_x;
	rec_map_y = map_y;
}

void RestoreXY()
{
	man_x = rec_man_x;
	man_y = rec_man_y;
	map_x = rec_map_x;
	map_y = rec_map_y;
}

//----------------------------------------------------------------
int CheckStatus()
{
    int x, y, iStatus;

    iStatus = 0;

    //ȡľ
    x = map_x + man_x;
    y = map_y + man_y;

    //߽վ
    if (x == 9 && y == 6)
    {
    	BackupXY();
        map_x = 0;
        map_y = 15;
        man_x = 8;
        man_y = 1;
        iStatus = 1;
    }

    //뿪վ
    else if (x == 9 && y == 16)
    {
        map_x = 5;
        map_y = 5;
        man_x = 4;
        man_y = 2;
        //RestoreXY();
        iStatus = 1;
    }

    //߽о
    else if (x == 17 && y == 6)
    {
        BackupXY();
        map_x = 0;
        map_y = 25-FIX_H;
        man_x = 5;
        man_y = 2+FIX_H;//2
        iStatus = 1;
    }

    //뿪о
    else if (x == 5 && y == 28)
    {
        //map_x = 13;
        //map_y = 5-FIX_H;
        //man_x = 4;
        //man_y = 2+FIX_H;
		RestoreXY();
        //ѾȡҺ
        if (g_iStory == 40)
        {
            DrawMap();
            DrawGraphic(man_x, man_y, OBJ_MAN);

            //ץ
            DisplayMessage(OBJ_MAN, "Who are you? What are you doing?!");
            DisplayMessage(OBJ_BADMANR, "Stop! I know that you the Doctor's friend. Come with me. Now!");
            //ǹ
            DisplayMessage(OBJ_MAN, "What? You kidnapped the Doctor?!");
            DisplayMessage(OBJ_BADMANR, "Shut up and come with me!");
            map_x = 21;
            map_y = 25;
            man_x = 5;
            man_y = 2;
            DrawMap();
            DrawGraphic(man_x, man_y, OBJ_MAN);
            DisplayMessage(OBJ_BADMANR, "We tried to get the Doctor to cooperate, but he refused. You will either persuade the Doctor for us, or we will never let you go!");
            DisplayMessage(OBJ_MAN, "So, the Doctor was locked down here...");
        }
        iStatus = 1;
    }

    //߽Լ
    else if (x == 12 && y == 2)
    {
    	BackupXY();
        map_x = 11;
        map_y = 16;
        man_x = 1;
        man_y = 2;
        iStatus = 1;
    }

    //뿪Լ
    else if (x == 11 && y == 18)
    {
        //map_x = 4;
        //map_y = 0;
        //man_x = 7;
        //man_y = 2;
        RestoreXY();
        iStatus = 1;
    }

    //߽ʿ
    else if (x == 1 && y == 2)
    {
    	BackupXY();
        map_x = 11;
        map_y = 20;//fix
        man_x = 1; //fix
        man_y = 2; //fix
        iStatus = 1;
    }

    //߽Զ¥
    else if (x == 26 && y == 8)
    {
    	BackupXY();
        map_x = 11;
        map_y = 25;
        man_x = 8;
        man_y = 2;
        iStatus = 1;
    }

    //뿪Զ¥
    else if (x == 20 && y == 27)
    {
        //map_x = 20;
        //map_y = 7;
        //man_x = 6;
        //man_y = 2;
        RestoreXY();
        iStatus = 1;
    }

    //߽վ2
    else if (x == 22 && y == 2)
    {
    	BackupXY();
        map_x = 0;
        map_y = 15;
        man_x = 1;
        man_y = 2;
        RapidBack();
        iStatus = 1;
    }

    //Ӳʿӵĺ뿪
    else if (x == 20 && y == 23)
    {
        //Ѿõ޵
        //if (Thing_IsExist(OBJ_CABINET_OPEN)) {
        if (MapData[20][19] == OBJ_CABINET_OPEN)
        {
            map_x = 0;
            map_y = 0;
            man_x = 4;
            man_y = 2;

            //߻زʿӵſ
            MapData[2][1] = OBJ_POLICE;
            iStatus = 1;
        }

        //δõ޵뿪
        else
        {
            man_x--;
            DisplayMessage(OBJ_MAN, "It was too difficult getting into the Doctor's home to just walk right out again. I can't leave without finding ~something~ important...");
            iStatus = 1;
        }
    }

    //Ӳʿӵǰ뿪
    else if (x == 12 && y == 23)
    {
        man_y--;
        DisplayMessage(OBJ_MAN, "The police officer may have returned already. I'll have to find another way out...");
        iStatus = 1;
    }

    //߽˳
    else if (x == 0 && (y >= 16 && y <= 18))
    {
        RapidMove();
        map_x = 20;
        map_y = 1;
        man_x = 2;
        man_y = 2;
        DrawMap();
        DrawGraphic(man_x, man_y, OBJ_MAN);
        DisplayMessage(OBJ_MAN, "Arriving in Xizhi.");
        iStatus = 1;
    }

    //ͨբ
    else if (x == 4 && (y == 16 || y == 18))
    {
        MapData[y][x] = OBJ_DOORCLOSE;
        iStatus = 1;
    }

    //뿪
    else if (x == 27 && y == 23)
    {

        //Ѿõֽ
        //if (Thing_IsExist(OBJ_TOILETPAPER)) {
        if (g_iStory == 50)
        {
            MapData[23][27] = OBJ_DOORCLOSE;
            iStatus = 1;
        }
    }

    //ϴ˯
    else if (x == 19 && y == 17)
    {
        DrawGraphic(man_x, man_y, OBJ_SLEEP);

        //ѾͲʿ̸
        if (g_iStory == 10)
        {
            DisplayMessage(OBJ_SLEEP, "I'm so tired... ZZZ...");
			ClearScreen();
            DisplayMessage(OBJ_BLANK, "The next day...");

            MapData[18][12] = OBJ_POLICE;
            map_x = 11;
            map_y = 16;
            man_x = 7;
            man_y = 1;
            DrawMap();
            DrawGraphic(man_x, man_y, OBJ_MAN);
            DisplayMessage(OBJ_MAN, "What is this police officer doing here? I'll go talk to him...");
            g_iStory = 15;
            iStatus = 1;
        }
        else
        {
            DisplayMessage(OBJ_SLEEP, "I'm not tired. I should go out for walk.");
            man_x--;
            iStatus = 1;
        }
    }
    return iStatus;
}

//----------------------------------------------------------------
int IsWalkable()
{
    char ch;

    ch = MapData[map_y + man_y][map_x + man_x];

    if (ch == OBJ_BLANK || ch == OBJ_DOOROPEN || ch == OBJ_RAPID5 || ch == OBJ_GLOBALVIEW7
     || ch == OBJ_STAIR1 || ch == OBJ_STAIR2 || ch == OBJ_OFFICE4 || ch == OBJ_HOME3
     || ch == OBJ_BED || ch == OBJ_DRHOUSE4 || ch == OBJ_RAPIDCAR1 || ch == OBJ_RAPIDCAR2 || ch == OBJ_RAPIDCAR3
    )
    {
        return 1;
    }
    else
    {
        return 0;
    }
}

void Talk()
{
    int x, y;

    x = man_x + map_x;
    y = man_y + map_y;

    //ڲʿӵ
    if ((x == 1 && y == 3))
    {
        if (g_iStory == 0)
        {
            DisplayMessage(OBJ_MAN, "Doctor? What are you doing out here? You look like you were daydreaming.");
            DisplayMessage(OBJ_DR,  "Ah, my boy! I have new research to publish!");
            DisplayMessage(OBJ_MAN, "That's great! But what do you look so worried about?");
            DisplayMessage(OBJ_DR,  "I fear that someone will use my research for evil...");
            DisplayMessage(OBJ_DR,  "I think that I was being followed by someone. And I've had some strange calls recently.");
            DisplayMessage(OBJ_MAN, "Oh my god! Doctor, you should call the police.");
            DisplayMessage(OBJ_DR,  "No, no. Maybe I am just paranoid. I don't want to cause problems with crazy theories.");
            g_iStory = 10;
        }
        else if (g_iStory == 10)
        {
            DisplayMessage(OBJ_DR, "It is getting late... Time to go home & sleep!");
        }

        //뾯Աڲʿ⽻̸
        else
        {
            if (MapData[2][1] == OBJ_POLICE)
            {
                DisplayMessage(OBJ_MAN,     "Mr. Policeman! Why are you in front of Doctor's house? Did something happen?!");
                DisplayMessage(OBJ_POLICE,  "It looks like the Doctor was abducted last night from his home. I have to secure the perimeter of the house so that we can investigate.");
                DisplayMessage(OBJ_MAN,     "Can't I go in? I am a good friend of the Doctor!");
                DisplayMessage(OBJ_POLICE,  "I'm afraid not. We can't risk someone destroying any clues or contaminating the scene.");
                DisplayMessage(OBJ_MAN,     "(If I want to get inside, I will have to distract the police first. Perhaps I can lure him away...)");
            }
        }
    }

    //ڼ
    else if (x == 13 && y == 18)
    {

        //뾯Աڼн̸
        if (g_iStory == 15)
        {
            DisplayMessage(OBJ_POLICE, "Excuse me for entering, but I'm with the police. Your neighbor, the Dr., has disappeared. We fear that he may have been abducted last night.");
            DisplayMessage(OBJ_MAN,    "Abducted! Why do you think that?");
            DisplayMessage(OBJ_POLICE, "Someone destroyed the lock on his door and really messed up the house. I received the report just this morning.");
            DisplayMessage(OBJ_POLICE, "Did the Dr. have any enemies, or has anything strange happened recently?");
            DisplayMessage(OBJ_MAN,    "... ...");
            DisplayMessage(OBJ_MAN,    "Nothing that I can think of...");
            DisplayMessage(OBJ_POLICE, "Did you hear or see anything strange last night?");
            DisplayMessage(OBJ_MAN,    "No, not a thing. I slept very well last night.");
            DisplayMessage(OBJ_POLICE, "If you think of anything that can help, please contact us.");
            DisplayMessage(OBJ_MAN,    "No problem.");
            g_iStory = 20;

            //Ա뿪
            MapData[18][12] = OBJ_BLANK;
            MapData[18][11] = OBJ_POLICE;
            DrawMap();
            DrawGraphic(man_x, man_y, OBJ_MAN);

            //delay(DELAY_TIME);
            MapData[18][11] = OBJ_BLANK;

            //Ավڲʿ
            MapData[2][1] = OBJ_POLICE;
            DrawMap();
            DrawGraphic(man_x, man_y, OBJ_MAN);
            DisplayMessage(OBJ_MAN, "Dr.'s disappearance must be related to his research, based upon what he said yesterday.");
            DisplayMessage(OBJ_MAN, "Getting the police involved may cause more suffering for the Doctor. I have to rescue him myself!");
            DisplayMessage(OBJ_MAN, "First, I should go examine the Dr.'s Lab.");
        }
        else
        {
            DisplayMessage(OBJ_MAN, "Nobody to talk to...");
        }
    }

    //Զ¥籦ǰ
    else if (x == 15 && y == 28)
    {
        DisplayMessage(OBJ_GIRL, "Hello, I'm HEC baby, may I help you?");
        DisplayMessage(OBJ_MAN,  "Ah, you're HEC baby! I want to ask...");
        DisplayMessage(OBJ_MAN,  "Want to get dinner together this evening?");
        DisplayMessage(OBJ_GIRL, "What? You came here to ask me on a date?");
        DisplayMessage(OBJ_MAN,  "Ah, in fact, I want to pick up my CC800.");
        DisplayMessage(OBJ_GIRL, "May I see your repair receipt, please?");
    }

    //оҺͲʿ̸
    else if ((x == 7 && y == 21) || (x == 8 && y == 22))
    {
        if (g_iStory >= 20)
        {
            DisplayMessage(OBJ_ASSISTANT, "I heard that the Dr. was abducted. I'm very worried.");
            DisplayMessage(OBJ_MAN,       "Don't worry, we are trying to rescue him!");
            DisplayMessage(OBJ_MAN,       "As the Dr.'s assistant, do you know anything about the Dr.'s recent research?");
            DisplayMessage(OBJ_ASSISTANT, "I don't know. Recently, the Dr. has been doing all of the research himself. Something about germs...");
            DisplayMessage(OBJ_MAN,       "Germs? Do you know where the Dr. keeps his important records?");
            DisplayMessage(OBJ_ASSISTANT, "He has a CC800 -- that's where he recorded all of his important things. But, it was broken, so he sent it off for repair.");
            DisplayMessage(OBJ_MAN,       "(It seems as though I need to find the Dr.'s CC800!)");
        }
        else
        {
            DisplayMessage(OBJ_ASSISTANT, "Hello, I am the Dr.'s assistant.");
            DisplayMessage(OBJ_MAN,       "Hello!");
        }
    }

    //ڼкͲʿ̸
    else if ((x == 28 && y == 28) || (x == 29 && y == 27))
    {

        //ձʱ
        if (g_iStory == 40)
        {
            DisplayMessage(OBJ_MAN, "Doctor, are you OK? What happened?");
            DisplayMessage(OBJ_DR,  "They want my recent research, an equation to synthesize a new germ.")
                           ;
            DisplayMessage(OBJ_MAN, "Equation? New germ?");
            DisplayMessage(OBJ_DR,  "Yes, the germs are highly corrosive.");
            DisplayMessage(OBJ_MAN, "Highly corrosive? Is this the equation? I got it from your cabinet.");
            DisplayMessage(OBJ_DR,  "Yes! How did you get it?");
            DisplayMessage(OBJ_MAN, "Oh no! What if I got the germs on me?! What if I start to melt?!");
            DisplayMessage(OBJ_DR,  "Take it easy! The germs die quickly outside of the inoculum.");
            DisplayMessage(OBJ_DR,  "And they need electricity to become corrosive, otherwise it could not be contained.");
            DisplayMessage(OBJ_MAN, "Right... I guess that I'm fine...");
            DisplayMessage(OBJ_DR,  "Don't say that just yet! We have to find a way to escape!");
        }

        //סͰ֮
        else if (g_iStory == 50)
        {
            DisplayMessage(OBJ_MAN, "I blocked the toilet. The leaking should distract the man...");
            DisplayMessage(OBJ_DR,  "I hope it will be successful!");
            BadManGoAway();
            g_iStory = 60;
        }

        //뿪֮
        else if (g_iStory == 60 || g_iStory == 70)
        {
            DisplayMessage(OBJ_MAN, "Success! The man has walked away.");
            DisplayMessage(OBJ_DR,  "We have to form an escape plan.");
        }
        else
        {
            DisplayMessage(OBJ_MAN, "...");
            DisplayMessage(OBJ_DR, "...");
        }
    }

    //ڼ֮к̸
    else if (x == 26 && y == 27)
    {
        if (MapData[y][x - 2] == OBJ_BADMANR)
        {
            DisplayMessage(OBJ_MAN,     "Let us out!");
            DisplayMessage(OBJ_BADMANR, "The Dr. promised to cooperate with us. There's no way to out!");
        }
    }
    else
    {
        DisplayMessage(OBJ_MAN, "Nobody to talk to...");
    }
}

//----------------------------------------------------------------
void Search()
{
    int x, y;

    x = map_x + man_x;
    y = map_y + man_y;

    //ںլ֮ǰ
    if (((x == 5 || x == 6 || x == 7) && (y == 3)) || (x == 8 && y == 2))
    {
        
        DisplayMessage(OBJ_MAN, "The mansion beside the Dr.'s home. Few people have ever seen anyone come or go. However, its security system is very strict.");
        DisplayMessage(OBJ_MAN, "Recently, a bird hit one of the windows, causing the alarms to be triggered. It was so loud that it got the whole neighborhood's attention.");
        return ;
    }

    //ڲʿ֮ǰ
    else if ((x == 1 || x == 2 || x == 3) && (y == 3))
    {
        DisplayMessage(OBJ_MAN, "The Dr. has lived here for several years, and I often come to his home. He is a good neighbor.");
        return ;
    }

    //ڼĹǰ
    else if (x == 18 && y == 17)
    {
        if (Thing_Add(OBJ_SLINGSHOT))
        {
            MapData[y - 1][x] = OBJ_CABINET_OPEN;
            DrawMap();
            DrawGraphic(man_x, man_y, OBJ_MAN);
            DisplayMessage(OBJ_MAN,       "A slingshot in the cabinet from my childhood. I used to be a great shot!");
            DisplayMessage(OBJ_SLINGSHOT, "Got a slingshot.");
            return ;
        }
    }

    //ԶƱǰ
    else if (x == 7 && y == 16)
    {
        DisplayMessage(OBJ_MAN, "There is a ticket machine.");
        return ;
    }

    //ڽբ
    else if (x == 5 && (y == 16 || y == 18))
    {
        DisplayMessage(OBJ_MAN, "Just a train, but I need ticket to pass.");
        return ;
    }

    //ʿеĹ
    else if (x == 19 && y == 21)
    {
        if (Thing_Add(OBJ_INVOICE))
        {
            MapData[y - 1][x] = OBJ_CABINET_OPEN;
            DrawMap();
            DrawGraphic(man_x, man_y, OBJ_MAN);
            DisplayMessage(OBJ_MAN,     "Found repair receipt of CC800. I can pick it up today! The address is in Xizhi, so I need go there by train.");
            DisplayMessage(OBJ_INVOICE, "Got a receipt.");
            return ;
        }
    }

    //оеĹ
    else if (x == 1 && y == 21)
    {
        DisplayMessage(OBJ_MAN, "The cabinet is locked with a secret code. The Dr. is a scatterbrain... perhaps the code is written down or saved somewhere...");
        return ;
    }

    //ڲеĹ
    else if (x == 26 && y == 22)
    {

        //õֽ
        if (Thing_Add(OBJ_TOILETPAPER))
        {
            MapData[y - 1][x] = OBJ_CABINET_OPEN;
            DrawMap();
            DrawGraphic(man_x, man_y, OBJ_MAN);
            DisplayMessage(OBJ_MAN,         "Found a large package of toilet paper. Now I'm not afraid of diarrhea!");
            DisplayMessage(OBJ_TOILETPAPER, "Got toilet paper.");
            return ;
        }
    }

    //е
    else if (x == 29 && y == 27)
    {
        DisplayMessage(OBJ_MAN, "This door seems to go outside. Hmm... it's locked...");
        return ;
    }
    DisplayMessage(OBJ_MAN, "Found nothing...");
}

//----------------------------------------------------------------
void UseThing()
{
    int iSelectID;
    char cThingID;
    int x, y;

    x = man_x + map_x;
    y = man_y + map_y;

    iSelectID = DisplayMenu(str_ThingBox, mem_ThingBox, max_ThingCount);
    if (iSelectID ==  - 1)
    {
        return ;
    }
    DrawMap();
    DrawGraphic(man_x, man_y, OBJ_MAN);
    cThingID = mem_ThingBox[iSelectID];
    if (cThingID == OBJ_SLINGSHOT)
    {
        if (x == 8 && y == 2 && g_iStory == 20)
        {
            DisplayMessage(OBJ_MAN, "Showtime!");
            DisplayMessage(OBJ_MAN, "Pow! I hit the window. I'm quite the Marksman!");
            DisplayMessage(OBJ_MAN, "~WooOOOoo~ The alarm is sounding!");
            PoliceSeekRichHouse();
        }
        else if ((x == 5 || x == 6 || x == 7) && (y == 3) && g_iStory == 20)
        {
            DisplayMessage(OBJ_MAN, "This spot is too obvious. I would get caught!");
        }
        else
        {
            DisplayMessage(OBJ_MAN, "I don't want to get into trouble...");
        }
    }

    //Ʊ
    else if (x == 7 && y == 16 && cThingID == OBJ_MONEY)
    {
        Thing_Exchange(OBJ_MONEY, OBJ_TICKET);
        DisplayMessage(OBJ_TICKET, "Got a ticket.");
    }

    //ͨբ
    else if ((x == 3 || x == 5) && (y == 16 || y == 18) && cThingID==OBJ_TICKET)
    {
        MapData[y][4] = OBJ_DOOROPEN;
    }

    //ȡ cc800
    else if (x == 15 && y == 28 && cThingID == OBJ_INVOICE)
    {
        Thing_Exchange(OBJ_INVOICE, OBJ_CC800);
        DisplayMessage(OBJ_MAN,  "Here is the receipt for my CC800.");
        DisplayMessage(OBJ_GIRL, "OK, Please wait...");
        DisplayMessage(OBJ_GIRL, "Here is your repaired CC800. Take care!");
        DisplayMessage(OBJ_MAN,  "Yeah, I will!");
        DisplayMessage(OBJ_MAN,  "(Found a code in the CC800. Now, I can open the Dr.'s cabinet!)");
        DisplayMessage(OBJ_CC800,"Got a CC800.");
    }

    //ȡҺ
    else if (x == 1 && y == 21 && cThingID == OBJ_CC800)
    {
        if (Thing_Add(OBJ_CHEMICAL))
        {
            MapData[y - 1][x] = OBJ_CABINET_OPEN;
            DrawMap();
            DrawGraphic(man_x, man_y, OBJ_MAN);
            DisplayMessage(OBJ_MAN, "Found a strange substance in the Dr.'s cabinet. I wonder what it is used for...");
            DisplayMessage(OBJ_MAN, "Maybe this was his research? I hope I can find some clue of the kidnapping.");
            DisplayMessage(OBJ_CHEMICAL, "Got germ-inoculum.");
            g_iStory = 40;
            MapData[7][16] = OBJ_BADMANR;
            MapData[7][18] = OBJ_BADMANL;
        }
    }

    //סͰ
    else if (((x == 26 && y == 22) || (x == 25 && y == 23)) && cThingID == OBJ_TOILETPAPER)
    {
        DisplayMessage(OBJ_MAN, "If I can block the toilet, water will overflow. That should draw some attention!");
        MapData[23][25] = OBJ_WATER;
        g_iStory = 50;
    }

    //ʹϸҺֻӳ
    else if (x == 29 && y == 27)
    {
        if (g_iStory == 60 && cThingID == OBJ_CHEMICAL)
        {
            DisplayMessage(OBJ_MAN, "I put germ-inoculum on the door. Now, it needs electricity...");
            g_iStory = 70;
        }
        else if (g_iStory == 70 && cThingID == OBJ_CELLPHONE)
        {
            DisplayMessage(OBJ_MAN, "The phone has a battery. Splice the wires so that it can discharge electricity!");
            MapData[27][30] = OBJ_BLANK;
            DrawMap();
            DrawGraphic(man_x, man_y, OBJ_MAN);
            DisplayMessage(OBJ_MAN, "Wow! The door melted! How dangerous!");
            DisplayMessage(OBJ_DR,  "Here we go!");
            g_iStory = 80;

            //The End
            TheEnd();
        }

        else if (g_iStory < 60)
        {
            DisplayMessage(OBJ_MAN, "A man is watching the door. It's too dangerous to run just now, so I must distract him.");
        }
        
        else
        {
            DisplayMessage(OBJ_MAN, "No effect...");
        }
    }

    //ʹж绰
    else if (cThingID == OBJ_CELLPHONE)
    {
        DisplayMessage(OBJ_MAN, "Du-Du... No signal. The phone is junk, it never has a signal. It is worthless for phonecalls...");
    }

    //¸Ա
    else if ((x == 1 && y == 3) && cThingID==OBJ_MONEY && MapData[2][1]==OBJ_POLICE)
    {
        DisplayMessage(OBJ_POLICE, "You want to bribe a police officer? That's a felony!");
        DisplayMessage(OBJ_MAN,    "N-n-no! I was kidding...");
    }

    else
    {
        DisplayMessage(OBJ_MAN, "No effect...");
    }
}

//----------------------------------------------------------------
void main()
{
    int x, y;
    int ch;
    int iDrawTimes;
    int iSelectID;

    memcpy(MapData, MapBackup, sizeof(MapData));
    //
    g_iStory = 0;
    cnt_MenuItem = 3;

    //  InitialThingBox();
    max_ThingCount = 2;
    mem_ThingBox[0] = OBJ_MONEY;
    mem_ThingBox[1] = OBJ_CELLPHONE;
    strcpy(str_ThingBox[0], "Money     ");
    strcpy(str_ThingBox[1], "Phone     ");

    man_x = 7;
    man_y = 2;
    map_x = 4;
    map_y = 0;

    iDrawTimes = 0;
    DrawMap();
    DrawGraphic(man_x, man_y, OBJ_MAN);
    Refresh();
    ch = KEY_HELP;
    for (;;ch=getchar())
    {
    	rec_x = man_x;
    	rec_y = man_y;
    	//
        if (ch == KEY_LEFT || ch=='a')
        {
            if (man_x > LCD_WIDTH_START)
            {
                man_x--;
                if (IsWalkable())
                {
                    if (man_x == LCD_WIDTH_START)
                    {
                        if (map_x > 0)
                        {
                            map_x--;
                            man_x++;
                        }
                    }
                }
                else
                {
                    man_x++;
                }
            }
        }
        else if (ch == KEY_RIGHT || ch=='d')
        {
            if (man_x < LCD_WIDTH_END)
            {
                man_x++;
                if (IsWalkable())
                {
                    if (man_x == LCD_WIDTH_END)
                    {
                        if (map_x < MAP_MAX_WIDTH_OBJ - LCD_MAX_WIDTH_OBJ)
                        {
                            map_x++;
                            man_x--;
                        }
                    }
                }
                else
                {
                    man_x--;
                }
            }
        }
        else if (ch == KEY_UP || ch=='w')
        {
            if (man_y > LCD_HEIGHT_START)
            {
                man_y--;
                if (IsWalkable())
                {
                    if (man_y == LCD_HEIGHT_START)
                    {
                        if (map_y > 0)
                        {
                            map_y--;
                            man_y++;
                        }
                    }
                }
                else
                {
                    man_y++;
                }

            }
        }
        else if (ch == KEY_DOWN || ch=='s')
        {
            if (man_y < LCD_HEIGHT_END)
            {
                man_y++;
                if (IsWalkable())
                {
                    if (man_y == LCD_HEIGHT_END)
                    {
                        if (map_y < MAP_MAX_HEIGHT_OBJ - LCD_MAX_HEIGHT_OBJ)
                        {
                            map_y++;
                            man_y--;
                        }
                    }
                }
                else
                {
                    man_y--;
                }
            }
        }
        else if (ch == KEY_ENTER || ch=='k'|| ch=='.' || ch==KEY_F1)
        {
            iSelectID = DisplayMenu(str_MenuItem, NULL, cnt_MenuItem);
            if (iSelectID == TALK)
            {
                DrawMap();
                DrawGraphic(man_x, man_y, OBJ_MAN);
                Talk();
            }
            else if (iSelectID == SEARCH)
            {
                DrawMap();
                DrawGraphic(man_x, man_y, OBJ_MAN);
                Search();
            }
            else if (iSelectID == USE)
            {
                DrawMap();
                DrawGraphic(man_x, man_y, OBJ_MAN);
                UseThing();
            }
        }
        else if (ch == KEY_HELP)
        {
        	ClearScreen();
            TextOut(0,0, "Press [Enter] to show menu:", WB_COPY);
            TextOut(0,13,"'Talk', 'Find', 'Use Item'", WB_COPY);
            TextOut(0,26,"The game is easy. Talk to ", WB_COPY);
            TextOut(0,39,"people and explore.       ", WB_COPY);
            TextOut(0,52,"Now, please rescue the Dr.", WB_COPY);
            TextOut(0,65,"You might save the world! ", WB_COPY);
            Refresh();
            getchar();
            ClearScreen();
            TextOut(0,0, "Programming: SnoopyZZ     ", WB_COPY);
            TextOut(0,13,"Original: Nothing and Lee ", WB_COPY);
            TextOut(0,26,"PS. We are Chinese, and I ", WB_COPY);
            TextOut(0,39,"trans it into English.    ", WB_COPY);
            TextOut(0,52,"Thanks Ryan Boyd! He give ", WB_COPY);
            TextOut(0,65,"me a new translation.     ", WB_COPY);
            Refresh();
            getchar();
        }
        else if (ch==KEY_ESC)
        {
            break;
        }

        DrawMap();

        x = map_x + man_x;
        y = map_y + man_y;

        if (iDrawTimes % 2)
        {
            DrawGraphic(man_x, man_y, OBJ_MAN);
        }
        else
        {
            DrawGraphic(man_x, man_y, OBJ_MAN2);
        }
        Refresh();

        if (CheckStatus())
        {
            iDrawTimes = 0;
            Delay(100);
            DrawMap();
            DrawGraphic(man_x, man_y, OBJ_MAN);
            Refresh();
        }
        iDrawTimes++;
    }
}

//----------------------------------------------------------------

